'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QMLRenderer = exports.registerQtComponentClass = exports.registerNativeComponentClass = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.getRoot = getRoot;
exports.render = render;

var _reactReconciler = require('react-reconciler');

var _reactReconciler2 = _interopRequireDefault(_reactReconciler);

var _findIndex = require('lodash/findIndex');

var _findIndex2 = _interopRequireDefault(_findIndex);

var _toArray = require('lodash/toArray');

var _toArray2 = _interopRequireDefault(_toArray);

var _without = require('lodash/without');

var _without2 = _interopRequireDefault(_without);

var _Registry = require('./Registry');

var _QMLComponent = require('./QMLComponent');

var _objectFactory = require('./object-factory');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// FIXME: remove this
exports.registerNativeComponentClass = _Registry.registerNativeComponentClass;
exports.registerQtComponentClass = _Registry.registerQtComponentClass;
var QMLRenderer = exports.QMLRenderer = (0, _reactReconciler2.default)({
  createInstance: function createInstance(type, props, rootInstance) {

    // FIXME: remove this
    if (type === 'qml') {
      var qmlContent = props.__qmlRawContent;
      var defaultProp = props.defaultProp || 'data';
      return (0, _objectFactory.makeElementNode)(type, defaultProp, qmlContent, rootInstance);
    }

    if (type === 'attribute') {
      var name = props.name;

      return (0, _objectFactory.makeAttributeNode)(name);
    }

    if (_Registry.Registry[type]) {
      var _Registry$type = _Registry.Registry[type],
          _qmlContent = _Registry$type.qmlContent,
          component = _Registry$type.component,
          _defaultProp = _Registry$type.defaultProp;

      if (_qmlContent) {
        return (0, _objectFactory.makeElementNode)(type, _defaultProp, _qmlContent, rootInstance);
      }
      if (component) {
        return (0, _objectFactory.makeElementNodeFromQtComponent)(type, _defaultProp, component, rootInstance);
      }
      throw new Error('bad implementation for type ' + type);
    }

    throw new Error('unknown type ' + type);
  },
  appendInitialChild: function appendInitialChild(parent, child) {
    // creating an attribute node
    if ((0, _objectFactory.isAttribute)(parent)) {
      parent.value = child;
      return;
    }

    // assigning an attribute node
    if ((0, _objectFactory.isAttribute)(child)) {
      var prevValue = parent.value[child.name];

      (0, _objectFactory.setAttribute)(parent, child.name, child);
    }

    // assign a child element to its parent
    // at this point we're only assign a child node to a parent node
    // notice that node.value is the actual QML Object
    parent.children.push(child);
  },
  finalizeInitialChildren: function finalizeInitialChildren(element, type, props, rootContainerInstance) {
    // attribute node doesn't need finalization
    if ((0, _objectFactory.isAttribute)(element)) {
      return;
    }

    (0, _QMLComponent.setInitialProps)(element.value, props);

    // child-less elements don't need finalization as well
    if (!element.children || element.children.length === 0) {
      return;
    }

    element.children.forEach(function (child) {});

    (0, _objectFactory.setAttribute)(element, element.defaultProp, element.children);
  },
  createTextInstance: function createTextInstance(text, rootContainerInstance) {
    // TODO
    return getOwnerDocument(rootContainerInstance).createTextNode(text);
  },
  getPublicInstance: function getPublicInstance(inst) {
    if (!(0, _objectFactory.isElement)(inst) && !(0, _objectFactory.isAttribute)(inst)) {
      throw new Error('invalid instance');
    }
    return inst.value;
  },
  prepareForCommit: function prepareForCommit() {},
  prepareUpdate: function prepareUpdate(domElement, type, oldProps, newProps) {
    return (0, _QMLComponent.diffProps)(domElement.value, oldProps, newProps);
  },
  resetAfterCommit: function resetAfterCommit() {},
  resetTextContent: function resetTextContent(domElement) {
    domElement.textContent = '';
  },
  getRootHostContext: function getRootHostContext(instance) {
    return {};
  },
  getChildHostContext: function getChildHostContext(instance) {
    // console.log('getChildHostContext');
    return {};
  },
  shouldSetTextContent: function shouldSetTextContent(type, props) {
    // console.log('shouldSetTextContent ---', type);
    // return (
    //   type === 'textarea' ||
    //   typeof props.data === 'string' ||
    //   typeof props.data === 'number' ||
    //   (typeof props.dangerouslySetInnerHTML === 'object' &&
    //     props.dangerouslySetInnerHTML !== null &&
    //     typeof props.dangerouslySetInnerHTML.__html === 'string')
    // );
    return false;
  },


  now: function now() {},

  useSyncScheduling: true,

  mutation: {
    appendChild: function appendChild(parent, child) {

      var propKey = (0, _objectFactory.isElement)(child) ? parent.defaultProp : child.name;
      (0, _objectFactory.setAttribute)(parent, propKey, child);
    },
    appendChildToContainer: function appendChildToContainer(containerQmlElement, topLevelChild) {
      containerQmlElement.data.push(topLevelChild.value);
    },
    removeChild: function removeChild(parent, child) {

      var propKey = (0, _objectFactory.isElement)(child) ? parent.defaultProp : child.name;

      // assuming propKey is always an array prop
      var list = parent.value[propKey];

      if (typeof list.push === 'function') {
        var index = (0, _findIndex2.default)(list, function (elm) {
          return elm === child.value;
        });
        var removingElm = list[index];
        parent.value[propKey] = (0, _without2.default)(list, removingElm);

        // TODO: move this back to pool
        (0, _objectFactory.release)(removingElm);
      } else {
        parent.value[propKey] = null;
      }
    },
    removeChildFromContainer: function removeChildFromContainer(containerQmlElement, child) {
      for (var i = containerQmlElement.data.length; i > 0; i--) {
        if (child.value == containerQmlElement.data[i]) {
          containerQmlElement.data[i].destroy();
          break;
        }
      }
    },
    insertBefore: function insertBefore(parent, child, beforeChild) {
      var propKey = (0, _objectFactory.isElement)(child) ? parent.defaultProp : child.name;

      // assuming propKey is always an array prop
      var list = (0, _toArray2.default)(parent.value[propKey]);
      var beforeChildIndex = (0, _findIndex2.default)(list, function (elem) {
        return elem === beforeChild.value;
      });
      list.splice(beforeChild - 1, 0, child.value);

      parent.value[propKey] = list;
    },
    commitUpdate: function commitUpdate(instance, preparedUpdateQueue) {
      (0, _QMLComponent.updateProps)(instance, preparedUpdateQueue);
    },
    commitMount: function commitMount(instance, updatePayload, type, oldProps, newProps) {},
    resetTextContent: function resetTextContent(domElement) {
      domElement.textContent = '';
    },
    commitTextUpdate: function commitTextUpdate(textInstance, oldText, newText) {
      textInstance.nodeValue = newText;
    }
  }
});

QMLRenderer.injectIntoDevTools({
  bundleType: 1, // 0 for PROD, 1 for DEV
  version: '0.1.0', // version for your renderer
  rendererPackageName: 'qml-renderer', // package name
  findHostInstanceByFiber: QMLRenderer.findHostInstance // host instance (root)
});

var containerMap = new WeakMap();

function getRoot(qmlContainer) {
  var prevRoot = containerMap.get(qmlContainer);

  if (prevRoot) {
    return prevRoot;
  }

  var container = QMLRenderer.createContainer(qmlContainer);
  var root = new Root(container, QMLRenderer);
  containerMap.set(qmlContainer, root);
  return root;
}

function render(elements, container) {
  var root = getRoot(container);
  root.render(elements);
}

var Root = function () {
  function Root(domRoot, renderer) {
    _classCallCheck(this, Root);

    this.renderer = renderer;
    this.internalRoot = domRoot;
  }

  _createClass(Root, [{
    key: 'render',
    value: function render(children) {
      this.renderer.updateContainer(children, this.internalRoot, null);
    }
  }, {
    key: 'unmount',
    value: function unmount() {
      this.renderer.updateContainer(null, this.internalRoot, null);
    }
  }]);

  return Root;
}();